# Make file for siseq tools
# General make commands.

OBJECTS = siseq 

FUNCTIONS = srfunc.o utility.o gtsqfn.o excdfn.o cdncfn.o extrfn.o trnsfn.o


all: libSeq.a $(OBJECTS)
	$(CP) $(OBJECTS) ../bin

Dmc.h: Dmc.h_unix Def.ig
	$(CAT) Def.ig Dmc.h_unix > Dmc.h 
	
# Targets

siseq:	getseq2.o extcds.o sprem.o cdsnuc.o tofast.o extrna.o clrgap.o \
	toprot1.o toprot6.o toRNA.o getclu.o clu2fa.o analcds.o \
	siseq.o libSeq.a
	$(CC) $(CFLAGS) -o siseq $? 

# Objects

siseq.o:	siseq.c Dmc.h
	$(CC) $(CFLAGS) -c siseq.c

sprem.o:	sprem.c Dmc.h
	$(CC) $(CFLAGS) -c sprem.c
	
srfunc.o:	srfunc.c Dmc.h
	$(CC) $(CFLAGS) -c srfunc.c

getseq2.o:	getseq2.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c getseq2.c
	
gtsqfn.o:	gtsqfn.c Dmc.h getseq2.h cmptbl.h
	$(CC) $(CFLAGS) -c gtsqfn.c
	
utility.o:	utility.c Dmc.h
	$(CC) $(CFLAGS) -c utility.c

extcds.o:	extcds.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c extcds.c

excdfn.o:	excdfn.c Dmc.h getseq2.h
	$(CC) $(CFLAGS) -c excdfn.c
	
cdsnuc.o:	cdsnuc.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c cdsnuc.c
	
cdncfn.o:	cdncfn.c Dmc.h getseq2.h
	$(CC) $(CFLAGS) -c cdncfn.c
	
tofast.o:	tofast.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c tofast.c
	
extrna.o:	extrna.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c extrna.c
	
extrfn.o:	extrfn.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c extrfn.c

clrgap.o:	clrgap.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c clrgap.c

toprot1.o:	toprot1.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c toprot1.c
	
toprot6.o:	toprot6.c Dmc.h getseq2.h glovar.h 
	$(CC) $(CFLAGS) -c toprot6.c

toRNA.o:	toRNA.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c toRNA.c

getclu.o:	getclu.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c getclu.c

clu2fa.o:       clu2fa.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c clu2fa.c

analcds.o:	analcds.c Dmc.h getseq2.h glovar.h
	$(CC) $(CFLAGS) -c analcds.c

libSeq.a: $(FUNCTIONS)
	ar cr libSeq.a $(FUNCTIONS)
	ranlib libSeq.a

# Utilities

clean:
	$(RM) core *.o $(OBJECTS) libSeq.a

#test:
#	cd ../test; if [ -x ./test.sh ]; then ./test.sh; fi

cleartest:
#	cd ../test; $(RM) outT* resultT*
	
init:	clean cleartest 
	$(RM) Dmc.h; \
	cd ../bin; $(RM) $(OBJECTS) 

distclean: init

install:
	cd ../bin; $(CP) $(OBJECTS) $(BINDIR)
	$(CP) libSeq.a $(LIBDIR)

