/*************************************************************************
Residue conversion table for complementary DNA
File name: comp_table.h

Naoki Sato 31 Dec. 1997

Added symbols for multiple meaning. April 29, 1999.
Added RNA complementary. May 17, 1999.
New conversion table n2c. May 27, 1999.
Bug fix. July 27, 2001.


Note:	D = A, G, T.	Complementary to H.
	H = A, C, T.	Complementary to D.
	K = G, T.	Complementary to M.
	M = A, C.	Complementary to K.
	N = A, C, G, T.
	R = A, G.	Complementary to Y.
	S = C, G.	Complementary to S.
	W = A, T.	Complementary to W.
	Y = C, T.	Complementary to R.

typedef enum residue_code {
_symbol,A, C, D, E, F, G, H, I, K, L, M, N, P, Q, R, S, T, U, V, W, X, Y}
        *  *  *        *  *     *     *  *        *  *  *  *     *     *
     0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,22  

	--- Do not delete this comment.---
**************************************************************************/

int comple_res[]={
     0,17, 6, 7, 0, 0, 2, 3, 0,11, 0, 9,12, 0, 0,22,16, 1, 1, 0,20, 0,15};

int comple_res_rna[]={
     0,18, 6, 7, 0, 0, 2, 3, 0,11, 0, 9,12, 0, 0,22,16, 1, 1, 0,20, 0,15};

/* new conversion table. May 27, 1999. */

char n2c[3][17]={"*ACDGHKMNRSTUWY-",	/* original residue */
                 "*TGHCDMKNYSAAWR-",	/* complementary DNA */
                 "*UGHCDMKNYSAAWR-"};	/* complementary RNA */
              


/***** end of file comp_table.h **********/
