/******************************************************
libSeq.h

lists prototype declarations of libSeq.a

Naoki Sato. June 15, 1999.

	Modified Sept. 1, 1999.
	Added calcseq.c. Dec. 7, 1999.
	Modified exon_list. Oct. 25, 2000.
	Modified trnsfn.c. Nov. 30, 2001.
	Added msanal.c. March 7, 2007.

Do not remove this comment.
******************************************************/
/* external variables */
#ifdef MAC
extern Boolean CMDQ;
#endif
extern long num_seq;

#ifndef __STAT
extern double get_kai2_level(double KI2,int n);
extern double Kai2(int n, double P);
extern double LogComb(long a, long n);
extern double get_signif(double x);
#endif

#ifndef __MSANAL
extern int MSanal(char *msdef, char *outfile,Seqfile **mseq);
#endif

#ifndef __CALCSEQ
extern int DumpSites(char *fname2, Seqfile **multiseq);
extern int RemoveGaps(Seqfile **multiseq,double level,int option);
extern int SelectSitesByInf(Seqfile **multiseq,double min, double max, enum data_type dtype1);
extern double InfContent(char *seq, long seqlen, enum data_type dtype1);
extern double getProtMW(Seqfile *protseq);
extern int MatchSeqN(char **seq1,char **seq2,char *seq_out,long seqlen_out,long match_len,double c,char *codon_table);
extern long MatchSeq(char *seq1,char *seq2,double c);
extern int massAlnCorrect(char *fnameList,char *fname2,double thr,char *nuc_file,long offset);
extern int alnCorrect(int mode,char *fname1,char *fname2,Seqfile **seqM,double thr,char *nuc_file,Seqfile **seq_nuc,char *org_name,long offset);
extern int alnStat(char *fname1, char *fname2, Seqfile **seqM, double thr);
extern int UnequalLength(Seqfile **seqM);
extern void PrintScTable(FILE *fout,long N0,SimilarityCounts **sc1,int sw);
extern int CountSimilarity(Seqfile *seq1,Seqfile *seq2,long N0,double st[30][30],SimilarityCounts **sc1,long pos);
extern int EraseCodingRegion(Seqfile *seq_in,Seqfile **seq_nuc,int c,Boolean retain_intron);
extern int CountNonCoding(Seqfile *seq_in,long *NumSeq,int c);
extern int SelectNonCoding(Seqfile *seq_in,Seqfile **seq_out,long *NumSeq,int c);
extern int c_basecomp(Seqfile *seq_in,double basecomp[4]);
extern int c_freq(Seqfile *seq_in,long *freq,long maxdist,int modeM);
extern int c_freq_i(Seqfile *seq_in,long *freq,long i,int modeM);
extern int c_comp(Seqfile *seq_in, long code_count[30]);
extern int c_comp_char(char *seq,long seqlen,long code_count[30]);
extern int codon_usage_comp(Seqfile *seq_in, long *code_count);
extern void initialize_comp2(long *code_count,unsigned dim);
extern void initialize_comp(long code_count[30]);
extern int c_basecomp_seq(char *seq,double basecomp[4]);
extern double CountGCSkew(char *seq);
extern double CountATSkew(char *seq);
extern double CountGC(char *seq);
#endif

#ifndef __CDNCFN
/* cdncfn.c */
extern void print_mutlist(char *fname2);
extern int check_se(char *start_loc,char *end_loc);
extern int add_seq_split(Seqfile *seq_in,Seqfile **seq_nuc,int n);
extern int add_seq_mutlist(char *fname2,Seqfile *seq_in,Seqfile **seq_nuc,MutList *mlist,int mutlist_num,char *codon);
extern int add_seq(Seqfile *seq_in,Seqfile **seq_nuc,char *start_loc,long startpos,char *end_loc,long endpos);
extern int ext_introns(Seqfile *seq_in,Seqfile *seq_nuc,Seqfile **seqM,char *start_loc,long startpos,char *end_loc,long endpos);
extern int add_seqG(Seqfile *seq_in,Seqfile **seq_nuc,char *start_loc,long startpos,char *end_loc,long endpos);
extern int exon_list(char *header,Exon_record **exon,char *comment);
extern void free_exon(Exon_record **exon,int exons);
extern Boolean TransSplicing(Exon_record **exon,int exons);
extern Boolean ExternalSequence(Exon_record **exon,int exons,char *ACstr);
extern Boolean ExternalSequence2(Exon_record *exon,char *ACstr);
extern char *getAC(char *ACstr);
extern int get_exon_number(char* header);
#endif

#ifndef __EXCDFN
/* excdfn.c */
extern char *getGeneName(char *string);
extern char *estimateGeneName(char *string);
extern int isGeneName(char *string);
extern int make_index(FILE *fin);
extern long ExternalSeqlen(char *AC);
extern Seqfile **extract_cds2(FILE *fin,Seqfile *seq_in,long *loc,enum filetype c,enum data_type dtype1);
extern int Mfwrite_Dinfo(FILE *fout,Seqfile **multi_seq,long window,long slide);
extern int Mwrite_Dinfo(char *filename, Seqfile **multi_seq,long window,long slide);
extern int Mfwrite_info(FILE *fout,Seqfile **multi_seq);
extern int Mwrite_info(char *filename, Seqfile **multi_seq);
extern int Mfwrite3(FILE *fout,Seqfile **multi_seq,long start, long end);
extern int Mwrite3(char *filename, Seqfile **multi_seq,long start, long end);
extern int Mfwrite2(FILE *fout,Seqfile **multi_seq,long min, long max);
extern int Mwrite2(char *filename, Seqfile **multi_seq,long min, long max);
extern int Mfwrite(FILE *fout,Seqfile **multi_seq);
extern int Mwrite(char *filename, Seqfile **multi_seq);
extern int Twrite(char *filename, Seqfile **multi_seq);
extern int Mfwrite_info2(FILE *fout,Seqfile **multi_seq,char info_mode_opt);
extern int Mwrite_info2(char *filename, Seqfile **multi_seq,char info_mode_opt);
extern int Mfwrite_info3(FILE *fout,Seqfile **multi_seq,char *codon_table);
extern int Mwrite_info3(char *filename, Seqfile **multi_seq,char *codon_file);
extern int write_codon_summary(FILE *fout,char *codon_table,long *code_count_total,long aalen);
extern Seqfile *retrve_cds(Seqfile **seq_cds, char *cdsname);
extern Seqfile *ext_exons(Seqfile *seq_nuc);
extern int show_gene_names(FILE *fout,Seqfile **seq_nuc);
extern int show_gene_table(FILE *fout,Seqfile **seq_nuc,enum data_type dtype1);
extern Seqfile *join_exons2(Seqfile *seq_nuc,Exon_record **exon,int exons,char *ACstr);
extern long exon_total(Exon_record **exon,int exons,char *ACstr,long seqlen);
extern long exon_total2(Exon_record **exon,int exons,char *ACstr,long seqlen);
#endif

#ifndef __GTSQFN
/* gtsqfn.c */
extern int check_filetype(char *filename);
extern Seqfile *read_seq(char *filename, int seqformat1, enum data_type dtype1);
extern Seqfile *read_fasta(FILE *fin,enum data_type dtype1);
extern Seqfile *read_genbank(FILE *fin,long *loc,enum data_type dtype1);
extern Seqfile *read_pir(FILE *fin,long *loc,enum data_type dtype1);
extern Seqfile *read_embl(FILE *fin,long *loc,enum data_type dtype1);
extern Seqfile *read_prf(FILE *fin,enum data_type dtype1);
extern int cat_seq(Seqfile *seq1,Seqfile *seq2);
extern int cat_aln(Seqfile **seq1,Seqfile **seq2);
extern Seqfile *empty_seq5(void);
extern Seqfile *extract_seq3(Seqfile *seqfile1, long startpos, long endpos);
extern int pick_seq(Seqfile *seqfile1, long startpos, long endpos);
extern int to_compD(int s); 
extern int to_compR(int s); 
extern int rev_seq(Seqfile *seqfile1);
extern int to_revM(Seqfile **seqfileM);
extern int comp_seq4(Seqfile *seqfile1);
extern int comp_seqM(Seqfile **seqfileM);
extern int to_rna(Seqfile *seqfile1);
extern int to_dna(Seqfile *seqfile1);
extern int to_rnaM(Seqfile **seqfileM);
extern int to_dnaM(Seqfile **seqfileM);
extern enum data_type check_data_type(Seqfile *seqfile1);
extern Boolean clear_gaps(Seqfile *seqfile1);
extern Boolean clear_gapsM(Seqfile **seqfileM);
extern Seqfile *copy_seq(Seqfile *seqfile1);
extern Seqfile *copy_seq_h(Seqfile *seqfile1);
extern void fprint_seq(FILE *file, Seqfile *seqfile1);
extern int print_seq(Seqfile *seqfile1);
extern void free_seq(Seqfile *seqfile1);
extern int fwrite_Dinfo(FILE *fout, Seqfile *seqfile1,long window,long slide);
extern int write_Dinfo(char *filename,Seqfile *seqfile1,long window,long slide);
extern int fwrite_info(FILE *fout, Seqfile *seqfile1,Boolean include_header,int id_h_sep);
extern int fwrite_info2(FILE *fout, Seqfile *seqfile1,char info_mode_opt);
extern int fwrite_info3(FILE *fout, Seqfile *seqfile1,char *codon_table,long *code_count);
extern int write_info(char *filename,Seqfile *seqfile1,Boolean include_header,int id_h_sep);
extern int fwrite_fasta(FILE *fout, Seqfile *seqfile1,Boolean include_header,int id_h_sep);
extern int write_fasta(char *filename,Seqfile *seqfile1,Boolean include_header,int id_h_sep);
extern int match_seq(Seqfile **seq,char *listfile,int mode_flag);
extern void sort_seq(Seqfile **seq);
extern Seqfile **read_clustal(char *filename, enum data_type dtype1);
extern void read_clustal2(char *filename, Seqfile **seqfile1);
extern int fwrite_clustal(FILE *fout, Seqfile **seqfile1, char *string, int ID_len);
extern int write_clustal(char *filename,Seqfile **seqfile1);
extern Seqfile **read_phylip(char *filename, enum data_type dtype1);
extern int fwrite_phylip(FILE *fout, Seqfile **seqfile1, int ID_len, int I_flag);
extern int write_phylip(char *filename,Seqfile **seqfile1, int ID_len, int I_flag);
extern int fwrite_mega(FILE *fout, char *fname,Seqfile **seqfile1);
extern int write_mega(char *filename,char *fname, Seqfile **seqfile1);
extern int fwrite_nexus(FILE *fout, Seqfile **seqfile1, int ID_len);
extern int write_nexus(char *filename,Seqfile **seqfile1);
extern long parse_position(char *position_str);
extern Seqfile *read_dbseq(FILE *fin,long *loc);
extern void mask_sequence(char *seq,int Ns, int Qs);
#endif

#ifndef __MRDFA
/* mrdfa.c */
extern Seqfile **Mread_fasta(char *filename, enum data_type dtype1);
#endif

#ifndef __SRFUNC
/* srfunc.c */
extern int select_from_menu(char *a);
extern int select_command(char *a, char *str);
extern void delete_character(char* fnameA, char* fnameB, char x);
extern void replace_character(char* fnameA, char* fnameB, char x, char y);
extern void delete_num(char *fnameA, char *fnameB);
extern void cr_lf2lf(char *fnameA, char *fnameB);
extern void cr_lf2cr(char *fnameA, char *fnameB);
extern void lf2cr_lf(char *fnameA, char *fnameB);
extern void to_lower(char *fnameA, char *fnameB);
extern void to_upper(char *fnameA, char *fnameB);
extern void delete_empty_line(char *fnameA, char *fnameB);
#endif


#ifndef __TRNSFN
/* trnsfn.c */
extern int codon_translate(char *string,char *codon_table);
extern int codon_usage(char *string);
extern char *translate(char *string,int frame, char *codon_table);
extern Seqfile *seq_translate(Seqfile *seqfile1, int frame, char *codon_file);
extern Seqfile *seq_translate2(Seqfile *seqfile1, int frame, char *codon_file, char *suffix);
extern Seqfile **seq_translateM(Seqfile **seqfileM, int frame, char *codon_file);
extern char *read_codon_table(char *codon_file);
extern int write_composite(char *fname2,Seqfile *seq_in,Seqfile **seq_out6,char *codon_file,int nc);
extern void help_codon_table(void);
extern ORF **AddOrfInfo(Seqfile *seqfile1, ORF **multiorf, int *NumOrf, char *codon_table, int nc);
extern ORF **InitOrfInfo(int NumOrf);
extern ORF **ReallocOrfInfo(ORF **multiorf, int NumOrf, int NewOrf);
extern int PrintOrfInfo(char *fname2, Seqfile *seqfile1, ORF **multiorf, int NumOrf, long MinLimit);
extern int PrintOrfSeq(char *fname2,Seqfile *seqfile1,ORF **multiorf,int NumOrf,long MinLimit,char *codon_file);
extern char *CodonTable(char *codon_file);
extern int get_codon(int s,char *string);
#endif


#ifndef __UTILITY
/* utility.c */
extern int filename_input(char* fname, char* message);
extern int copy_file(char *fnameA, char *fnameB);
extern int copy_file2(char *fnameA, char *fnameB, int start, int end);
extern int copy_stream(FILE *fin,FILE *fout);
extern int ftouch(char *filename);
extern int StringClearGaps(char *s);
extern Boolean linetype(char *line,char *code);
extern char *extract_string(char *str_name, long int startpos, long int endpos);
extern void extract_string2(char *str, long startpos, long endpos,char *out);
extern int pick_string(char *str_name, long int startpos, long int endpos);
extern void string_alnum(char *string,char *list);
extern void pack_seq(char *string,char *list);
extern void pack_space(char *string);
extern void remove_character(char *string,char c1);
extern void pack_multispace(char *string);
extern int count_char(char *string,int s);
extern int count_characters(char *string);
extern int count_alnum(char *string);
extern int num_check(char *string);
extern int num_check2(char *string);
extern int int_check(char *string);
extern void tail_string(char *string,int s);
extern Boolean last_line(char *string);
extern void pause_screen(void);
extern char *space_line(long size,int c);
extern void subst(char *string, char c1, char c2);
extern Boolean tailtype(char *line, char *code);
extern Boolean blank_line(char *str);
extern void tailchop(char *string);
extern void headchop(char *string);
extern char *str_shift(char *string,char delimit);
extern void erasequote(char *string);
extern void fill_both_sides(char *string,long a,long b,int s);
extern int siseq_rm(int c, char (*p)[50]);
extern int siseq_cp(int c, char (*p)[50]);
extern int fcat(int c, char (*p)[50]);
extern int ipow(int a,int c);
extern void version_info(FILE *stream);
extern int catch_word(char *s, char *last);
#endif


#ifndef __PRETTY
/* pretty.c */
extern int make_header(Seqfile *seqfile1,char *exon_file);
extern int fwrite_pretty(FILE *fout,Seqfile *seqfile1,char *exon_file,char *codon_file);
extern int write_pretty(char *fname,Seqfile *seqfile1,char *exon_file,char *codon_file);
#endif

/************** end of file libSeq.h *******************/

