/*****************************************************
Text transformer 
Program name :	txtr
File name : Srfunc.c
	
	Functions : 
				select_from_menu
				select_command
				delete_character
				replace_character
				delete_num
				cr_lf2lf
				cr_lf2cr
				lf2cr_lf
				to_lower
				to_upper
				delete_empty_line
				justify
				
	
	Naoki Sato Sept. 1996

	Integrated Mac, DOS, and UNIX version.
	August 1997
	Modified Jan 1998 (transferred filename_input and 
		copy_file to utility.c)

	Bugs fixed. Nov. 21, 1998.
	Bug fix in lf2cr_lf. June 15, 1999.
	Japanese messages. Feb. 4, 2000.
	Added replace_character. Feb. 21, 2000.
	Inclusion of japanese files. March 2, 2000.
	Justify. Oct. 23, 2000.
	Bug fix. delete_empty_line. June 19, 2001.

	--- Do not delete this comment.---

******************************************************/

#include "Dmc.h"
#include "def.h"

/* Prototype declaration */

int select_from_menu(char *a);
int select_command(char *a, char *str);
void delete_character(char* fnameA, char* fnameB, char x);
void replace_character(char* fnameA, char* fnameB, char x, char y);
void delete_num(char *fnameA, char *fnameB);
void cr_lf2lf(char *fnameA, char *fnameB);
void cr_lf2cr(char *fnameA, char *fnameB);
void lf2cr_lf(char *fnameA, char *fnameB);
void to_lower(char *fnameA, char *fnameB);
void to_upper(char *fnameA, char *fnameB);
void delete_empty_line(char *fnameA, char *fnameB);
void justify(char *fnameA, char *fnameB, int len);

/* External functions */

extern int filename_input(char* fname, char* message);
extern void copy_file(char *fnameA, char *fnameB);
extern void copy_file2(char *fnameA, char *fnameB, int start, int end);
extern int num_check(char *string);

/* External variables */
#ifdef MAC
extern Boolean CMDQ;
#endif

/******************************************************/
int select_from_menu(char *a)
/******************************************************/
{
	
	char str[10];

	while(TRUE)
	{
		printf("\n");
		printf("      ------------------------------------------------------------\n");

#ifdef JAPANESE

#ifdef UNIX	
#include "EUC/srfE1.h"
#else 
#ifdef MAC
#include "Mac/SJIS/srfS1.h"
#else
#include "Dos/SJIS/srfS1.h"
#endif
#endif

#else
		printf("                   Selection Menu\n");
		printf("\n");
		printf("         1. Delete spaces from the text.\n");
		printf("         2. Delete spaces and isolated numbers from the text.\n");
		printf("         3. Delete a user-defined character from the text.\n");
		printf("         4. Uppercase to lowercase.\n");
		printf("         5. Lowercase to uppercase.\n");
		printf("         6. Delete empty lines.\n");
		printf("         7. Copy file.\n");
		printf("         CR or cr. change LF or CR for the current system.\n");
		printf("         J or j. Right-justify lines to a user-defined length.\n");
		printf("         C or c. Copy lines from xxx to yyy. Use cxxx-yyy in command line.\n");
		printf("         exit. <e> Exit program.\n");
		printf("\n");
		printf("                   Enter your selection and press <return>.\n");
#endif
		printf("      ------------------------------------------------------------\n");
		printf("\n");
		scanf("%s",str);
		if(!strcmp(str,"exit") || !strcmp(str,"e")) return 0;
		if(!strcmp(str,"1")) return 1;
		if(!strcmp(str,"2")) return 2;
		if(!strcmp(str,"3")) {
			while(TRUE){
#ifdef JAPANESE

#ifdef UNIX	
#include "EUC/srfE2.h"
#else 
#ifdef MAC
#include "Mac/SJIS/srfS2.h"
#else
#include "Dos/SJIS/srfS2.h"
#endif
#endif

#else
				printf("                  Enter a single character to delete.\n\n");
#endif
				scanf("%s",str);
				strcpy(a,str);
#ifdef JAPANESE

#ifdef UNIX	
#include "EUC/srfE3.h"
#else 
#ifdef MAC
#include "Mac/SJIS/srfS3.h"
#else
#include "Dos/SJIS/srfS3.h"
#endif
#endif

#else
				printf("Do you wish to delete character <%c>?\n",a[0]);
				printf("If so, confirm by entering <%c> again.\n",a[0]);
				printf("To exit, type <exit>.\n\n");
#endif
				scanf("%s",str);
				if((strcmp(str,"exit"))==0)
					exit(0);
				else if(strcmp(a,str)==0)
					return 3;
				else
					printf("              Error!\n\n");
			}
		}
		if(!strcmp(str,"4") || !strcmp(str,"u") || !strcmp(str,"U")) return 4;
		if(!strcmp(str,"5") || !strcmp(str,"l") || !strcmp(str,"L")) return 5;
		if(!strcmp(str,"6")) return 6;
		if(!strcmp(str,"7")) return 7;

		if(!strcmp(str,"8") || !strcmp(str,"J") || !strcmp(str,"j")) {
			fflush(stdin);
			while(TRUE){
				printf("                  Enter line length.\n");
				printf("                  <exit> to abort.\n\n");
				fflush(stdin);
				scanf("%s",str);
				if(!strcmp(str,"exit")){
					fprintf(stderr,"Exiting..\n");
#include 	"exit0.h"
				}
				strcpy(a,str);
				if(!num_check(a)) break;
			}
			return 8;
		}

		if(((strcmp(str,"CR"))==0) || ((strcmp(str,"cr"))==0))

#ifdef MAC
			return 91;
#endif
#ifdef DOS
			return 92;
#endif
#ifdef UNIX
			return 93;
#endif

		if((strcmp(str,"set"))==0)
			return 99;
	}
}

/******************************************************/
int select_command(char *a, char *str)
/******************************************************/
{
	

		if((strcmp(str,"exit")==0) || (strcmp(str,"e")==0))
			return 0;
		if((strcmp(str,"1"))==0) return 1;
		if((strcmp(str,"2"))==0) return 2;
		if(*(str)=='3'){
			strcpy(a,(str+1));
			return 3;
		}
		if(!strcmp(str,"4") || !strcmp(str,"u") || !strcmp(str,"U"))
			return 4;
		if(!strcmp(str,"5") || !strcmp(str,"l") || !strcmp(str,"L"))
			return 5;
		if(!strcmp(str,"6")) return 6;
		if(!strcmp(str,"7")) return 7;

		if(!strcmp(str,"CR") || !strcmp(str,"cr"))

#ifdef MAC
			return 91;
#endif
#ifdef DOS
			return 92;
#endif
#ifdef UNIX
			return 93;
#endif

		if(*(str)=='J' || *(str)=='j'){
			strcpy(a,(str+1));
			return 8;
		}

		if(*str == 'c' || *str == 'C'){
			strcpy(a,(str+1));
			return 71;
		}

		if((strcmp(str,"set"))==0)
			return 99;
		
		else 
			return 98;
			
}

/******************************************************/
void justify(char *fnameA,char *fnameB,int len)
/******************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int s=20;

	if(len<2) len=PRINTLINE;
	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}

#ifdef MAC
#ifdef CODEWARRIOR
	_fcreator=CREATOR_NAME;
	_ftype=FILETYPE_NAME;
#endif
#endif

	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
	
	while((s=getc(fin))!=EOF){
		if(isupper(s)) s=tolower(s);
		if(s=='\n' || s=='\r') continue;
		else if(!isprint(s)) s=' ';
		putc(s,fout);
		if (((c++)%100)==0){
			printf(".");
			fflush(stdout);
		}
		if((c%len)==0){
			fprintf(fout,"\n");
		}
	}
		
	fclose(fin);
	fclose(fout);
	printf("\n");
	return;

}

/******************************************************/
void delete_character(char* fnameA, char* fnameB, char x)
/******************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int s=20;

	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}

#ifdef MAC
#ifdef CODEWARRIOR
	_fcreator=CREATOR_NAME;
	_ftype=FILETYPE_NAME;
#endif
#endif

	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
	
		
	while((s=getc(fin))!=EOF){
		if(s!=x)
			putc(s,fout);
		if (((c++)%100)==0){
			printf(".");
			fflush(stdout);
		}
	}
		
	fclose(fin);
	fclose(fout);
	printf("\n");
	return;
}

/******************************************************************/
void replace_character(char* fnameA, char* fnameB, char x, char y)
/******************************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int s=20;

	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}

#ifdef MAC
#ifdef CODEWARRIOR
	_fcreator=CREATOR_NAME;
	_ftype=FILETYPE_NAME;
#endif
#endif
	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
	
	while((s=getc(fin))!=EOF){
		if(s!=x) putc(s,fout);
		else putc(y,fout);
		if (((c++)%100)==0){
			printf(".");
			fflush(stdout);
		}
	}
		
	fclose(fin);
	fclose(fout);
	printf("\n");
	return;
}


/******************************************************/
void delete_num(char *fnameA, char *fnameB)
/******************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int i=1;
	int end_of_num=0;
	int s=20;
	char numbuf[30]="";
	int _num1,_num2,_numtrain;
	_num1=_num2=_numtrain=0;

	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}

#ifdef MAC
#ifdef CODEWARRIOR
	_fcreator=CREATOR_NAME;
	_ftype=FILETYPE_NAME;
#endif
#endif

	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
		
	while((s=getc(fin))!=EOF){
		if((s>=33) && (s<=126))  _num2=2;
		if(isdigit(s))
			_num2=1;	/* _num is 2, if s is a printable character (not space).
						           1, if s is a number.
						           0, if s is a control character or space. */
						           
		if((_numtrain>=1) && (_num2==1)){
			_numtrain++;	/* addition of number to number train */
			if(_numtrain>30){
				printf("\nThere is a long stretch of numbers,\n");
				printf("which cannot be removed automatically.\n");
				end_of_num=1;
			}
			else{
				numbuf[_numtrain-1]=s;
				numbuf[_numtrain]=0;
			}
		}

		if((_num1==0) && (_num2==1)){
			_numtrain=1;	/* start of number train */
			numbuf[_numtrain-1]=s;
			numbuf[_numtrain]=0;
		}
			
		if((_numtrain>=1) && (_num2==0)){
				_numtrain=0;	/* End of number. Proceed to next character. */
				strcpy(numbuf,"");
		}

		if((_numtrain>=1) && (_num2==2)){
			end_of_num=1;	/* Numbers are followed by a character. */
		}	
		if(end_of_num==1){	/* When numbers are followed by a character, they are
								written in the output file. */
			for(i=0;i<=(_numtrain-1);i++){
				putc(numbuf[i],fout);
			}
			end_of_num=0;
			strcpy(numbuf,"");
			_numtrain=0;
		}
		if(_numtrain==0) putc(s,fout);
		_num1=_num2;
		_num2=0;
		
		if (((c++)%100)==0){
			printf(".");
			fflush(stdout);
		}
	}
		
	fclose(fin);
	fclose(fout);
	printf("\n");
	return;
}

/******************************************************/
void to_lower(char *fnameA,char *fnameB)
/******************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int s=20;

	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}

#ifdef MAC
#ifdef CODEWARRIOR
	_fcreator=CREATOR_NAME;
	_ftype=FILETYPE_NAME;
#endif
#endif

	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
	
	while((s=getc(fin))!=EOF){
		if(isupper(s)) s=tolower(s);
		putc(s,fout);
		if (((c++)%100)==0){
			printf(".");
			fflush(stdout);
		}
	}
		
	fclose(fin);
	fclose(fout);
	printf("\n");
	return;

}

/******************************************************/
void to_upper(char *fnameA, char *fnameB)
/******************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int s=20;

	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}

#ifdef MAC
#ifdef CODEWARRIOR
	_fcreator=CREATOR_NAME;
	_ftype=FILETYPE_NAME;
#endif
#endif

	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
	
	while((s=getc(fin))!=EOF){
		if(islower(s))
			s=toupper(s);
		putc(s,fout);

		if (((c++)%100)==0){
			printf(".");
			fflush(stdout);
		}
	}
		
	fclose(fin);
	fclose(fout);
	printf("\n");
	return;

}

/******************************************************/
void cr_lf2lf(char *fnameA, char *fnameB)

/* This function converts mac file or dos file to 
unix file.*/
/******************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int s=0;
	int _lf1,_lf2,_cr1,_cr2;
	_lf1=0;
	_lf2=0;
	_cr1=0;
	_cr2=0;

	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}

	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
		
	while((s=getc(fin))!=EOF){
		_cr2=0;
		_lf2=0;
		if(s==10)
			_lf2=1;
		if(s==13)
			_cr2=1;
		if(_lf1==1){
			if(_cr2==1){
				fputc(10,fout);
				_lf1=0;
				_cr1=0;
			}
			else if(_lf2==1){
				fputc(10,fout);
				_lf1=1;
				_cr1=0;
			}
			else{
				fputc(10,fout);
				fputc(s,fout);
				_lf1=0;
				_cr1=0;
			}
		}

		else if(_cr1==1){
			if(_lf2==1){
				fputc(10,fout);
				_lf1=0;
				_cr1=0;
			}
			else if(_cr2==1){
				fputc(10,fout);
				_lf1=0;
				_cr1=1;
			}
			else{
				fputc(10,fout);
				fputc(s,fout);
				_lf1=0;
				_cr1=0;
			}
		}
		else{
			if((_cr2==1) || (_lf2==1)){
				_lf1=_lf2;
				_cr1=_cr2;
			}
			else{
				fputc(s,fout);
				_lf1=0;
				_cr1=0;
			}
		}
	
		if(((c++)%100)==0){
			printf(".");
			fflush(stdout);
		}
	}
		
	if((_lf1==1) || (_cr1==1)) fputc(10,fout);

	fclose(fin);
	fclose(fout);
	printf("\n");
	return;

}

/******************************************************/
void cr_lf2cr(char *fnameA, char *fnameB)

/* This function converts unix file or dos file to 
mac file. Apparently, this function is identical to
the previous one, but CodeWarrior somehow manages to
change this to a correct one.*/
/******************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int s=0;
	int _lf1,_lf2,_cr1,_cr2;
	_lf1=0;
	_lf2=0;
	_cr1=0;
	_cr2=0;

	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}

#ifdef MAC
#ifdef CODEWARRIOR
	_fcreator=CREATOR_NAME;
	_ftype=FILETYPE_NAME;
#endif
#endif

	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
		
	while((s=getc(fin))!=EOF){
		_cr2=0;
		_lf2=0;
		if(s==10)
			_lf2=1;
		if(s==13)
			_cr2=1;
		if(_cr1==1){
			if(_lf2==1){
				fputc(10,fout);
				_lf1=0;
				_cr1=0;
			}
			else if(_cr2==1){
				fputc(10,fout);
				_lf1=0;
				_cr1=1;
			}
			else{
				fputc(10,fout);
				fputc(s,fout);
				_lf1=0;
				_cr1=0;
			}
		}

		else if(_lf1==1){
			if(_cr2==1){
				fputc(10,fout);
				_lf1=0;
				_cr1=0;
			}
			else if(_lf2==1){
				fputc(10,fout);
				_lf1=1;
				_cr1=0;
			}
			else{
				fputc(10,fout);
				fputc(s,fout);
				_lf1=0;
				_cr1=0;
			}
		}
		else {
			if((_cr2==1) || (_lf2==1)){
				_lf1=_lf2;
				_cr1=_cr2;
			}
			else{
				fputc(s,fout);
				_lf1=0;
				_cr1=0;
			}
		}
	
		if(((c++)%100)==0){
			printf(".");
			fflush(stdout);
		}
	}
		
	if((_lf1==1) || (_cr1==1)) fputc(10,fout);

	fclose(fin);
	fclose(fout);
	printf("\n");
	return;

}

/******************************************************/
void lf2cr_lf(char *fnameA, char *fnameB)

/* This function converts mac file or unix file to 
dos file. Changed June 15, 1999. */
/******************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int s=0;
	int _lf1,_lf2,_cr1,_cr2;
	_lf1=0;
	_lf2=0;
	_cr1=0;
	_cr2=0;

	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}
	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
		
	while((s=getc(fin))!=EOF){
		_cr2=0;
		_lf2=0;
		if(s==10)
			_lf2=1;
		if(s==13)
			_cr2=1;
		if(_lf1==1){
			if(_cr2==1){
				fputc('\n',fout);
				_lf1=0;
				_cr1=0;
			}
			else if(_lf2==1){
				fputc('\n',fout);
				_lf1=1;
				_cr1=0;
			}
			else{
				fputc('\n',fout);
				fputc(s,fout);
				_lf1=0;
				_cr1=0;
			}
		}

		else if(_cr1==1){
			if(_lf2==1){
				fputc('\n',fout);
				_lf1=0;
				_cr1=0;
			}
			else if(_cr2==1){
				fputc('\n',fout);
				_lf1=0;
				_cr1=1;
			}
			else{
				fputc('\n',fout);
				fputc(s,fout);
				_lf1=0;
				_cr1=0;
			}
		}
		else {
			if((_cr2==1) || (_lf2==1)){
				_lf1=_lf2;
				_cr1=_cr2;
			}
			else{
				fputc(s,fout);
				_lf1=0;
				_cr1=0;
			}
		}
	
		if(((c++)%100)==0){
			printf(".");
			fflush(stdout);
		}
	}
		
	if((_lf1==1) || (_cr1==1)){
		fputc('\n',fout);
	}

	fclose(fin);
	fclose(fout);
	printf("\n");
	return;

}

/******************************************************/
void delete_empty_line(char *fnameA, char *fnameB)
/******************************************************/
{
	FILE *fin, *fout;
	int c=1;
	int getline = MAXLINE * 4 - 2;
	char s[MAXLINE * 4];
	char *p;

	if((fin=fopen(fnameA,"r"))==NULL){
		printf("Cannot open file: %s\n\n",fnameA);
		exit(1);
	}

#ifdef MAC
#ifdef CODEWARRIOR
	_fcreator=CREATOR_NAME;
	_ftype=FILETYPE_NAME;
#endif
#endif

	if((fout=fopen(fnameB,"w"))==NULL){
		printf("Cannot open file: %s\n\n",fnameB);
		exit(1);
	}
		
	while(fgets(s,getline,fin)!=NULL){
		if(strlen(s) >= 2){		/* linelength is normally longer than 2.*/
			for(p=s;*p!='\0';p++){
				if((*p)!=' ' && (*p)!='\t' && (*p)!='\r' && (*p)!='\n'){
					fprintf(fout,"%s",s);
					break;
				}
			}
		}

/*
		if(strlen(s)>=2)
			fputs(s,fout);
*/

		if (((c++)%10)==0){
			printf(".");
			fflush(stdout);
		}
	}
		
	fclose(fin);
	fclose(fout);
	printf("\n");
	return;
}


/******************************************************
		 End of file srfunc.c 
******************************************************/

