/* This file is part of the SISEQ package. 

	Naoki Sato, Nov. 21, 1998 version 1.07
	version 1.08. Dec. 28, 1998.
	version 1.09. Feb. 14, 1998.
	version 1.10. March 13, 1999.
	version 1.11. May 3, 1999.
	version 1.12. May 6, 1999.
	version 1.13. May 19, 1999.
	version 1.14. May 21, 1999.
	version 1.15. May 23, 1999.
	version 1.16. May 25, 1999.
	version 1.17. June 3, 1999.
	version 1.18. Aug. 30, 1999.
	version 1.19. abandoned.
	version 1.20. Oct. 17, 1999.
	version 1.21. Dec. 8, 1999.
	version 1.22. Dec. 19, 1999.
	version 1.23. Feb. 21, 2000.
	version 1.24. July 24, 2000.
	version 1.30. Nov. 28, 2000.
		pre43: cdsnuc: extraction of DNA is enabled for truncated ORF with s 0 e 0 option.
		pre44: nucaln: use of MatchSeqN for making nucleic alignment for spliced amino acid alignment.
		pre45: excdfn.c: psudo tag allowed
		pre46: calcseq.c: RemoveSites and SelectSitesByInf added. This enables option gap and inf in getclu.
		pre47: gtsqfn.c: write_nexus added
		pre48: utility.c: copy_file2 added
		pre49: tofast.c, excdfn.c: sequence count output added
		pre50: sites.c, bug fix.
		51: processing of = in seqname in nucaln.
		52: processing of = in seqname in making nex file.
		53: output of individual exons with xxxxx interleaved.
		54: bug fix.
		55: extended reading of /product.
		56: exon_inf mode.
		57: file, group, and split modes in getent.
		58: nr_mode and list_mode in simtbl.
		59: monoisotopic mw.
	version 1.59.1 March. 7, 2007.
		Adaptation to UniProt.
		Analysis of MS.
	version 1.59.2 March. 8, 2007.
		Bug fix for MS analysis.
	version 1.59.3 March 15, 2007.
		Bug fix in simtbl.
	version 1.59.4 March 23, 2007.
		Bug fix in trnsfn.c.
	version 1.59.5 April 20, 2007.
		Bug fix in gtsqfn.c.
	version 1.59.6 May 2, 2007.
		Bug fix in excdfn.c.
		Adaptation to the new EMBL format.
	version 1.59.7 May 3, 2007.
		Changes in mrdfa.c.
	version 1.59.8 May 11, 2007.
		Changes in tofast.c.
		Addition of pack_multispace in utility.c
	version 1.59.9 June 29, 2007.
		Addition of mask_sequence in gtsqfn.c
		Added mode mask in tofast
	version 1.59.10 Jan. 11, 2008.
		Changes in excdfn.c: modified getGeneName to better parse RNA names.
	version 1.59.11 Jan. 14, 2008.
		Added options in RemoveGaps in calcseq.c.
	version 1.59.12 Jan. 20, 2008.
		Modified to_rna and to_dna in gtsqfn.c to allow identical type conversion.
	version 1.59.13 Feb. 4, 2008.
		Added artificial sequence reversal in tofast and getclu.
	version 1.59.14 Feb. 19, 2008.
		Bug fix in nucaln.c.
	version 1.59.15 April 13, 2008.
		Added match option in getclu.
	version 1.59.16 May 20, 2008.
		Added match2 option in getclu.
	version 1.59.17 May 20, 2008.
		Bug fix in nucaln.
	version 1.59.18 Oct. 29, 2008.
		Phylip format output extended.
	version 1.59.19 Nov. 7, 2008.
		GI number output in cdsnuc, extcds.
	version  1.59.20 Aug. 18, 2009.
		Bug fix in getent.c.
	version  1.59.21 Sept. 27, 2009.
		Cdsnuc split mode: number of x characters.
	version 1.59.22 Jan. 5, 2010.
		Length of AC is allowed to be >30.
	version 1.59.23 Feb. 14, 2010.
		Added match1 option in getclu.
	version 1.59.24 Feb. 15, 2010.
		Added Z-curve method in the b option of tofast.
	version 1.59.25 Feb. 17, 2010.
		Added conversion to MEGA format in getclu.
	version 1.59.26 April 11, 2010.
		Modified excdfn.c to allow note tag.
	version 1.59.27 April 12, 2010.
		Modified simtbl.c to overcome data type error.
		Changed members of SimilarityCount from double to long.
	version 1.59.28 April 28, 2010.
		Added List mode in getent.
	version 1.69.29 May 28, 2010
		Added stat mode in getclu: alnStat
	version 1.59.30 June 2, 2010
		Added mode 4 in sites.c.
	version 1.59.31 June 6, 2010
		Added mutlist mode in cdsnuc.
	version 1.59.32. June 26, 2010
		Bug fix in getent for reading long lines.
	version 1.59.33. June 28, 2010.
		Modified getent: Sequence name with only numericals is skipped in file mode.
	version 1.59.34. July 13, 2010
		Added list_limit_mode in getent.
	version 1.59.35. Aug. 11, 2010
		Added ph40 option in getclu.
	version 1.59.36. Sept. 26, 2010
		Added correct mode in getclu.
	vrsion 1.59.37. Oct. 26, 2010
		Added mass correct mode in getclu.
	version 1.59.38-9. March 29 - April 7, 2011
		Code modified in getent.
	version 1.59.40. April 22, 2011
		Bug fix in utility.c.
	version 1.59.41. May 18, 2011
		Bug fix in calcseq.c
	version 1.59.42. Aug. 5, 2011
		Added comp option in getclu.
	version 1.59.43. Feb. 13, 2015 
		Bug fix in excdfn.
	version 1.59.44. Oct. 02, 2017.
		Removal of warnings.
		Added average measure in simtbl.
		Added sort_name and site_dump in getclu.
	last modified. Oct. 02, 2017.

	All rights reserved.
*/
#ifndef __VERSION_H
#define __VERSION_H

char version_string[20]="1.59.44";

#endif

/* end of file version.h */
