#!/bin/sh
# This script tests functions of the program txtr.

BINDIR="../bin"

if [ ! -x ${BINDIR}/siseq ]
then
	echo "Program siseq is not executable."
	exit 1
fi

echo "Now the command txtr is being tested."
echo " "
echo " "
list_commands="1 2 3e 4 5 6 7"
for var in $list_commands
do
	echo "Testing command "$var
	echo " "
	filename="resultT"$var
	${BINDIR}/siseq txtr testfile $filename $var
	echo " "
	echo "-----------------------------------------------------"
	echo "Here is the result of command "$var
	echo "saved in file "$filename
	echo "....................................................."
	cat $filename
	echo " "
	echo "-----------------------------------------------------"
	echo "End of test "$var
	echo ""
done

echo "Now comparing with authentic result files..."
echo ""

echo "1"
diff -s resultT1 Result1
echo "2"
diff -s resultT2 Result2
echo "3"
diff -s resultT3e Result3e
echo "4"
diff -s resultT4 Result4
echo "5"
diff -s resultT5 Result5
echo "6"
diff -s resultT6 Result6
echo "7"
diff -s resultT7 Result7

echo "Test complete."
echo ""
# end of script testtxtr.sh

